%{
/*
** $Id: lexer.l,v 1.2 2004/11/20 20:01:25 root Exp root $
** $Log: lexer.l,v $
** Revision 1.2  2004/11/20 20:01:25  root
** - Log entries.
**
*/
#define YY_INPUT(buf,result,max_size) \
    { \
    int c = getnextchar(); \
    result = (c == EOF) ? YY_NULL : (buf[0] = c, 1); \
    }

#include <string.h>
#include "gtkdialog.h"
#include "parser.h"

char *process_string(char *str);

extern int linenumber;
char *Token;
%}

%%

">"       { Token=">"; return(yytext[0]); }
$[ \t\n]* { Token="indent chars"; }

[-a-zA-Z_]+=/\" { 
                 Token="tag attribute";
		 yylval.cval=strdup(yytext);
		 return TAG_ATTR_NAME;
               }

 /* allow XML/HTML-style comments */
"<!--"(.|\n)*"-->" { ; }
 /* allow C-style comments */
"/*"(.|\n)*"*/" { ; }
 /* allow shell-style comments */
"#".* { ; }


\<wtitle\>    	{ Token="<wtitle>"; return(WTITLE);  	}
\<\/wtitle\>  	{ Token="</wtitle>"; return(EWTITLE);  	}

 /* GN below attempt to handle 0.8.0 syntax */
\<window.*\>		{ ; }
\<\/window\>		{ ; }

 /* Containers */
\<vbox\>     { Token="<vbox>"; return(VBOX);    }
\<\/vbox\>   { Token="</vbox>"; return(EVBOX);   }

 /* GN below attempt to handle 0.8.0 syntax */
 /* \<vbox\ .*\>	{ Token="<vbox>"; return(VBOX);    } */
\<vbox[ ]+ { Token="<vbox>"; return(PART_VBOX);	 } 

\<hbox\>     { Token="<hbox>"; return(HBOX);    }
\<\/hbox\>   { Token="</hbox>"; return(EHBOX);   }

 /* GN below attempt to handle 0.8.0 syntax */
 /* \<hbox\ .*\>  { Token="<hbox>"; return(HBOX);    } */
\<hbox[ ]+ { Token="<hbox>"; return(PART_HBOX);	 }

\<notebook\>     { Token="<notebook>"; return(NOTEBOOK);    }
\<\/notebook\>   { Token="</notebook>"; return(ENOTEBOOK);   }
\<notebook[ ]+  { Token="<notebook>"; return(PART_NOTEBOOK); }

\<frame\>    { Token="<frame>"; yylval.cval="";  return(FRAME); }
\<frame\ [^\>]+\>     {
       			Token="<frame>";
                        yylval.cval=strdup(&yytext[7]);  
                        yylval.cval[strlen(yylval.cval)-1]=0;
                        return(FRAME); 
                      }
\<\/frame\>   { Token="</frame>"; return(EFRAME);   }

 /*GN: below seems not to be used anywhere
\<title\>    { Token="<title>"; return(BEGINTITLE); }
\<\/title\>  { Token="</title>"; return(ENDTITLE);   }
 */

 /* text, label and pixmap widgets */
\<text\>     { Token="<text>"; return(TEXT);   }
\<\/text\>   { Token="</text>"; return(ETEXT);   }

 /* GN below attempt to handle 0.8.0 syntax */
\<text\ .*\>		{ Token="<text>"; return(TEXT);   }

\<label\>    { Token="<label>"; return(LABEL);    }
\<\/label\>  { Token="</label>"; return(ELABEL);  }
\<pixmap\>   { Token="<pixmap>"; return(PIXMAP); }
\<\/pixmap\> { Token="</pixmap>"; return(EPIXMAP); }


 /* attributes */
\<default\>      { Token="<default>"; return(DEFAULT);  }
\<\/default\>    { Token="</default>"; return(EDEFAULT);  }
\<visible\>      { Token="<visible>"; return(VISIBLE);  }
\<\/visible\>    { Token="</visible>"; return(EVISIBLE);  }

 /* GN below attempt to handle 0.8.0 syntax */
\<sensitive\>      { Token="<visible>"; return(VISIBLE);  }
\<\/sensitive\>    { Token="</visible>"; return(EVISIBLE);  }

\<variable\>     { Token="<variable>"; return(VARIABLE); }
\<\/variable\>   { Token="</variable>"; return(EVARIABLE); }
\<height\>       { Token="<height>"; return(HEIGHT);  }
\<\/height\>     { Token="</height>"; return(EHEIGHT);  }
\<width\>        { Token="<width>"; return(WIDTH);   }
\<\/width\>      { Token="</width>"; return(EWIDTH);   }
\<tooltip\>      { Token="<tooltip>"; return(TOOLTIP); }
\<\/tooltip\>    { Token="</tooltip>"; return(ETOOLTIP); }

 /* Widgets */
\<entry\>    { Token="<entry>"; return(ENTRY);   }
\<\/entry\>  { Token="</entry>"; return(EENTRY); }
\<entry[ ]+  { Token="<entry>"; return(PART_ENTRY); }
\<edit\>     { Token="<edit>"; return(EDIT);     }
\<\/edit\>   { Token="</edit>"; return(EEDIT);   }

 /* GN below attempt to handle 0.8.0 syntax */
\<edit\ .*\> { Token="<edit>"; return(EDIT);     }

\<tree\>     { Token="<table>"; return(TABLE);  	}
\<\/tree\>   { Token="</table>"; return(ETABLE);  	}

 /* GN below attempt to handle 0.8.0 syntax */
\<tree\ .*\>   { Token="<table>"; return(TABLE);  	}


\<chooser\>     { Token="<chooser>"; return(CHOOSER);     }
\<\/chooser\>   { Token="</chooser>"; return(ECHOOSER);   }

\<button\>    { Token="<button>"; return(BUTTON);  }
\<\/button\>  { Token="</button>"; return(EBUTTON);  }

 /* GN below attempt to handle 0.8.0 syntax */
\<button\ sensitive.*\>		{ Token="<button>"; return(BUTTON);  }
\<button\ image.*\>		{ Token="<button>"; return(BUTTON);  }

\<button\ ok\>      { Token="<button>"; return(BUTTONOK);  }
\<button\ cancel\>  { Token="<button>"; return(BUTTONCANCEL);  }
\<button\ help\>    { Token="<button>"; return(BUTTONHELP);  }
\<button\ yes\>     { Token="<button>"; return(BUTTONYES);  }
\<button\ no\>      { Token="<button>"; return(BUTTONNO);  }

\<checkbox\>	{ Token="<checkbox>"; return(CHECKBOX);  }
\<\/checkbox\>  { Token="</checkbox>"; return(ECHECKBOX);  }

 /* GN below attempt to handle 0.8.0 syntax */
\<checkbox\ .*\>   { Token="<checkbox>"; return(CHECKBOX);  	}

\<radiobutton\>    { Token="<radiobutton>"; return(RADIO);  }
\<\/radiobutton\>  { Token="</radiobutton>"; return(ERADIO);  }
\<radio\>    { Token="<radio>"; return(RADIO);  }
\<\/radio\>  { Token="</radio>"; return(ERADIO);  }

\<combobox\>    { Token="<combobox>"; return(COMBO);  	}
\<\/combobox\>  { Token="</combobox>"; return(ECOMBO);  }

 /* GN below attempt to handle 0.8.0 syntax */
\<combobox\ .*\>    { Token="<combobox>"; return(COMBO);  	} 
 

\<list\>    	{ Token="<list>"; return(LIST);  	}
\<\/list\>  	{ Token="</list>"; return(ELIST);  	}
\<table\>    	{ Token="<table>"; return(TABLE);  	}
\<\/table\>  	{ Token="</table>"; return(ETABLE);  	}
\<menubar\>    	{ Token="<menubar>"; return(MENUBAR);  	}
\<\/menubar\>  	{ Token="</menubar>"; return(EMENUBAR);	}
\<menu\>    	{ Token="<menu>"; return(MENU);  	}
\<\/menu\>  	{ Token="</menu>"; return(EMENU);	}
\<menuitem\>    { Token="<menuitem>"; return(MENUITEM);  	}
\<\/menuitem\>  { Token="</menuitem>"; return(EMENUITEM);	}

\<separator\>   { Token="<separator>"; return(SEPARATOR);  		}
\<\/separator\>	{ Token="</separator>"; return(ESEPARATOR);		}


\<hseparator\>   { Token="<hseparator>"; return(HSEP);  		}
\<\/hseparator\> { Token="</hseparator>"; return(EHSEP);		}
\<vseparator\>   { Token="<vseparator>"; return(VSEP);  		}
\<\/vseparator\> { Token="</vseparator>"; return(EVSEP);  		}

\<item\>     { Token="<item>"; return(ITEM);      }
\<\/item\>   { Token="</item>"; return(EITEM);    }
\<item[ ]+   { Token="<item>"; return(PART_ITEM); }


 /* remote-socket widgets */
\<gvim\>     { Token="<gvim>"; return(GVIM);  }
\<\/gvim\>   { Token="</gvim>"; return(EGVIM);  }
\<swallow\>     { Token="<swallow>"; return(SWALLOW);  }
\<\/swallow\>   { Token="</swallow>"; return(ESWALLOW);  }

 /* input and output tags */
\<input\>        { Token="<input>"; return(INPUT);   }
\<\/input\>      { Token="</input>"; return(EINPUT);   }
\<\input\ file\> { Token="<input file>"; return(INPUTFILE);   }
\<\input\ file[ ]+ { Token="<input file>"; return(PART_INPUTFILE);   }
\<\input\ [ ]*   { Token="<input>"; return(PART_INPUT);   }

\<output\>        { Token="<output>"; return(OUTPUT);   }
\<\/output\>      { Token="</output>"; return(EOUTPUT);   }
\<\output\ file\> { Token="<output>"; return(OUTPUTFILE);   }


 /* actions */
\<action\ clear\>            { Token="<action>"; return(ACTIONCLEAR);  }
\<action\ removeselected\>   { Token="<action>"; return(ACTIONREMOVE); }
\<action\ fileselection\>    { Token="<action>"; return(ACTIONFILESEL);}
\<action\ refresh\>          { Token="<action>"; return(ACTIONREFRESH);}
\<action\ launchwindow\>     { Token="<action>"; return(ACTIONLAUNCH); }
\<action\ insert\>           { Token="<action>"; return(ACTIONAPPEND); }
\<action\ append\>           { Token="<action>"; return(ACTIONAPPEND); }
\<action\ copy\>             { Token="<action>"; return(ACTIONAPPEND); }
\<action\ closewindow\>      { Token="<action>"; return(ACTIONCLOSE);  }
\<action\ disable\>          { Token="<action>"; return(ACTIONDISABLE);}
\<action\ enable\>           { Token="<action>"; return(ACTIONENABLE); }
\<action\ exit\>             { Token="<action>"; return(ACTIONEXIT);   }
\<action\ save\>             { Token="<action>"; return(ACTIONSAVE);   }

\<action\>                   { Token="<action>"; return(ACTION);      }
\<action[ ]+                 { Token="<action>"; return(PART_ACTION); }
\<\/action\>                 { Token="</action>"; return(EACTION);    }

 /* GN below attempt to handle 0.8.0 syntax */
\<action\ signal=\".*\"\>	        { Token="<action>"; return(ACTION);       }
\<action\ type=\"clear\"\>          { Token="<action>"; return(ACTIONCLEAR);  }
\<action\ type=\"removeselected\"\> { Token="<action>"; return(ACTIONREMOVE); }
\<action\ type=\"fileselect\"\>     { Token="<action>"; return(ACTIONFILESEL);}
\<action\ type=\"refresh\"\>        { Token="<action>"; return(ACTIONREFRESH);}
\<action\ type=\"launch\"\>	        { Token="<action>"; return(ACTIONLAUNCH); }
\<action\ type=\"insert\"\>	        { Token="<action>"; return(ACTIONAPPEND); }
\<action\ type=\"append\"\>	        { Token="<action>"; return(ACTIONAPPEND); }
\<action\ type=\"copy\"\>	        { Token="<action>"; return(ACTIONAPPEND); }
\<action\ type=\"closewindow\"\>    { Token="<action>"; return(ACTIONCLOSE);  }
\<action\ type=\"disable\"\>	    { Token="<action>"; return(ACTIONDISABLE);}
\<action\ type=\"enable\"\>	        { Token="<action>"; return(ACTIONENABLE); }
\<action\ type=\"exit\"\>	        { Token="<action>"; return(ACTIONEXIT);   }
\<action\ type=\"save\"\>           { Token="<action>"; return(ACTIONSAVE);   }
\<action\ type=\"command\"\>	    { Token="<action>"; return(ACTION);       }

 /* unknown tags */
\<\/[^> ]*\>   { Token=strdup(yytext); 
		yyerror("Unknown end tag.");    }
\<[^> ]*\>     { Token=strdup(yytext); 
		yyerror("Unknown tag.");    }

 /* quoted strings */
\"[^\"]*\"  {
	Token="quoted string";
	yylval.cval=process_string(&yytext[1]);
	yylval.cval[strlen(yylval.cval)-1]='\0';
	return(STRING);
}

 /* GN: below from 0.58 and fix quotes in strings...but break action type="xx" */
 /* original */
[^ \n\t\>\<\"][^\<\>\n\"]*  {
 /* from 0.58 */
 /* [^ \n\t][^\<\>\n]*  {     */
	Token="STRING";
	yylval.cval=strdup(yytext);
 /*	Token=yylval.cval;	*/
	return(STRING);
}

\n { 
	++linenumber;
   }

[\t ] {
 /* 
  */
}

%%

char *process_string(char *str){
  //fprintf(stderr, "%s(): Input = '%s'\n", __func__, str);
  // FIXME: Well, this will come tomorrow...
  return strdup(str);
}
